require 'socket'
require 'thread'
require './common'

$server_host = ARGV.shift
$server_port = ARGV.shift
$port = ARGV.shift

class P4UClient
  # 
  def initialize
    # OC
    @server = TCPSocket.open($server_host, $server_port)
    @listen = TCPServer.open($port)
    $host = @server.gets.chop!
    puts("-> accepted")
    # Oǂݍ
    @uploads = []
    return unless File.exist?("upload.ini")
    File.open("upload.ini", "r") {|f|
      while line = f.gets do
        info = create_info(line.chop)
        add_file(info) if info
      end
    }
  end
  
  # Avv
  def main
    send_thread = Thread.new {
      send_listen
    }
    local_session
    send_thread.kill
  end
  
  # ㏈
  def finalize
    # O
    File.open("upload.ini", "w") {|f|
      while @uploads.size > 0 do
        info = @uploads[0]
        f.puts(info.name)
        del_file(info)
      end
    }
    # \Pbg
    @listen.close
    @server.close
    puts("-> closed")
  end
  
  # Mp
  def send_listen
    while true do
      Thread.new(@listen.accept) {|s|
        send_session(s)
      }
    end
  end
  
  # [JUI
  def local_session
    while line = gets do
      case line.chop
      when /^add\s+(\S.*)$/
        info = create_info($1)
        add_file(info) if info
      when /^del\s+(\S.*)$/
        info = create_info($1)
        del_file(info) if info
      when /^get\s+(\S+)$/
        Thread.new($1) {|hash|
          recv_session(hash)
        }
      when /^ls(?:\s+(\S+))?$/
        dir = $1 || "."
        get_list(dir)
      when /^quit$/
        break
      else
        puts("-> undefined operation")
      end
    end
  end
  
  # t@C𑗐M
  def send_session(sock)
    begin
      # t@C𒊏o
      hash = sock.gets.chop
      array = @uploads.clone
      @uploads.delete_if {|f|
        f.hash != hash
      }
      # t@C𑗐M
      info = array[0]
      puts("-> sending #{info.name}")
      File.open(info.name, "rb") {|f|
        data = f.read
        sock.write(data)
      }
      puts("-> #{info.name} sended")
    rescue
      sock.close
      puts("-> sending failed")
    end
  end
  
  # t@CM
  def recv_session(hash)
    begin
      # t@C𒊏o
      array = []
      @server.puts("HASH #{hash}")
      size = @server.gets.chop.to_i
      size.times {
        info = unpack(@server.gets.chop)
        array.push(info)
      }
      # t@CM
      info = array[0]
      puts("-> receiving #{info.name}")
      sock = TCPSocket.open(info.host, info.port)
      sock.puts(info.hash)
      File.open(info.name, "wb") {|f|
        data = sock.read(info.size)
        f.write(data)
      }
      sock.close
      puts("-> #{info.name} received")
    rescue
      puts("-> receiving failed")
    end
  end
  
  # t@Cǉ
  def add_file(info)
    data = pack(info)
    @server.puts("ADD #{data}")
    @uploads.push(info)
    puts(@server.gets)
  end
  
  # t@C폜
  def del_file(info)
    data = pack(info)
    @server.puts("DEL #{data}")
    @uploads.delete(info)
    puts(@server.gets)
  end
  
  # t@C
  def get_list(word)
    @server.puts("LS #{word}")
    size = @server.gets.chop.to_i
    size.times {
      info = unpack(@server.gets.chop)
      puts("#{info.name} (#{info.hash}) [#{info.size}]")
    }
    puts("-> no such a file") if size == 0
  end
end

begin
  client = P4UClient.new
  client.main
rescue
  puts("#{$!}")
ensure
  client.finalize
  exit(0)
end
