require 'socket'
require 'digest/md5'

# t@C̍\
FileInfo = Struct.new(:name, :size, :host, :port, :hash)

# t@CFileInfo𐶐
def create_info(filename)
  unless File.exist?(filename) then
    puts("-> no such a file")
    return nil
  end
  info = FileInfo.new
  info.name = filename
  info.size = File.stat(filename).size
  info.host, info.port = $host, $port
  File.open(filename, "rb") {|f|
    data = f.read
    info.hash = Digest::MD5.hexdigest(data)
  }
  return info
end

# FileInfo -> String
def pack(info)
  "#{info.name}//#{info.size}//" +
  "#{info.host}//#{info.port}//#{info.hash}"
end

# String -> FileInfo
def unpack(str)
  info = FileInfo.new
  array = str.split('//')
  info.name, info.size = array[0], array[1].to_i
  info.host, info.port = array[2], array[3].to_i
  info.hash = array[4]
  return info
end
