require 'socket'
require 'thread'
require './common'

$port = ARGV.shift

class P4UServer
  # 
  def initialize
    @table = []
    @listen = TCPServer.open($port)
  end
  
  # Avv
  def main
    client_thread = Thread.new {
      client_listen
    }
    local_session
    client_thread.kill
  end
  
  # ㏈
  def finalize
    @listen.close
  end
  
  # [JUI
  def local_session
    while (line = gets) do
      case line.chop
      when /^quit$/
        break
      else
        puts("-> undefined operation")
      end
    end
  end
  
  # NCAg҂
  def client_listen
    while true do
      Thread.new(@listen.accept) {|s|
        client_session(s)
      }
    end
  end
  
  # NCAgUI
  def client_session(sock)
    # OC
    remote_host = sock.peeraddr[2]
    sock.puts(remote_host)
    puts("-> #{remote_host} connected")
    # 
    while line = sock.gets.chop do
      case line
      when /^ADD\s+(\S+)$/
        add_table(sock, $1)
        puts("-> ADD #{$1}")
      when /^DEL\s+(\S+)$/
        del_table(sock, $1)
        puts("-> DEL #{$1}")
      when /^LS\s+(\S.*)$/
        put_list(sock, $1)
        puts("-> LS #{$1}")
      when /^HASH\s+(\S+)$/
        put_hash(sock, $1)
        puts("-> HASH #{$1}")
      else
        puts("-> undefined operation")
      end
    end
    # OAEg
    puts("-> #{remote_host} leaved")
    sock.close
  end
  
  # t@Cǉ
  def add_table(sock, data)
    info = unpack(data)
    if @table.include?(info) then
      sock.puts("-> #{info.name} already exist")
    else
      @table.push(info)
      sock.puts("-> #{info.name} added")
    end
  end
  
  # t@C폜
  def del_table(sock, data)
    info = unpack(data)
    if @table.include?(info) then
      @table.delete(info)
      sock.puts("-> #{info.name} deleted")
    else
      sock.puts("-> #{info.name} isn't exist")
    end
  end
  
  # ʂ𑗐M
  def put_list(sock, dir)
    # Mf[^̏
    array = @table.clone
    array.delete_if {|info|
      not info.name.include?(dir)
    }
    array.map! {|info|
      pack(info)
    }
    # f[^𑗐M
    sock.puts("#{array.size}")
    array.each {|info|
      sock.puts(info)
    }
  end
  
  # nbVʂ𑗐M
  def put_hash(sock, hash)
    # Mf[^̏
    array = @table.clone
    array.delete_if {|info|
      info.hash != hash
    }
    array.map! {|info|
      pack(info)
    }
    # f[^𑗐M
    sock.puts("#{array.size}")
    array.each {|info|
      sock.puts(info)
    }
  end
end

begin
  server = P4UServer.new
  server.main
rescue
  puts("#{$!}")
ensure
  server.finalize
  exit(0)
end
